<html>
    <head>
        <title>Accumulate Dashboard</title>
        <link rel="icon" href="https://accumulatenetwork.io/wp-content/uploads/2021/09/blue-icon-acc.svg" sizes="192x192">
        <script defer src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/4.1.1/crypto-js.min.js" integrity="sha512-E8QSvWZ0eCLGk4km3hxSsNmGWbLtSCSUcewDQPQWZF6pEU8GlT8a5fF32wOl1i8ftdMhssTrF/OhyGWwonTcXA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/knockout/3.5.1/knockout-latest.debug.js" integrity="sha512-per7WBYe3cT9aIDMoF74rYR7wpEDPqyncWqWzBGmJBnhp8H3ZD5fRdTM16IO5ePUEuBlH9DMKF7rHvuazhvDBA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
        <!-- <script defer src="https://cdnjs.cloudflare.com/ajax/libs/knockout/3.5.1/knockout-latest.min.js" integrity="sha512-vs7+jbztHoMto5Yd/yinM4/y2DOkPLt0fATcN+j+G4ANY2z4faIzZIOMkpBmWdcxt+596FemCh9M18NUJTZwvw==" crossorigin="anonymous" referrerpolicy="no-referrer"></script> -->
        <script defer src="knockout-projections.min.js"></script>
        <script defer src="main.js"></script>
        <script>window.addEventListener('load', () => ko.applyBindings(new ViewModel([
            'http://bvn0-seed.mainnet.accumulatenetwork.io:16591',
            'http://bvn1-seed.mainnet.accumulatenetwork.io:16591',
            'http://bvn2-seed.mainnet.accumulatenetwork.io:16591',
            'http://accumulate.detroitledger.tech:16591',
            'http://validator-eu01.acme.sphereon.com:16591',

            // 'http://38.135.195.84:16591',
            // 'http://testnet1.federate-this.com:16591',
            // 'http://195.191.219.115:16591',
            // 'http://20.79.250.168:16591',
            // 'http://15.223.88.158:16591',
            // 'http://testnet.accumulate.detroitledger.tech:16591',
            // 'http://testnet2.federate-this.com:16591',
            // 'http://34.123.194.109:16591',
            // 'http://15.204.175.104:16591',
            // 'http://18.218.131.215:16591',
            // 'http://95.217.142.50:16591',
            // 'http://50.17.246.3:16591',
            // 'http://65.109.48.173:16591',
            // 'http://104.248.171.142:16591',
        ])))</script>

        <style>
            html {
                display: flex;
                justify-content: center;
                align-items: center;
                font-family: sans-serif;
            }

            .mono {
                font-family: monospace, sans-serif;
            }

            body {
                min-width: 800px;
                max-width: 1500px;
            }

            input[type=text] {
                width: 100%;
            }

            ul {
                display: flex;
                flex-flow: column;
                list-style: none;
            }

            li {
                display: flex;
            }

            li > input {
                flex: 1;
            }

            li.bad > input {
                border: 1px inset red;
                border-radius: 2px;
            }

            th, td {
                padding: 3px;
            }

            th {
                background: hsl(0, 0%, 90%);
                padding: 0 0.5em;
            }

            tr:nth-child(2n) {
                background: hsl(0, 0%, 95%);
            }

            tr:nth-child(2n+1) {
                background: hsl(0, 0%, 98%);
            }

            tr:hover {
                background: hsl(0, 0%, 90%);
            }

            .status-behind {
                background: hsla(40, 80%, 60%, 0.2);
            }

            .status-syncing {
                background: hsla(20, 80%, 60%, 0.2);
            }

            .status-bad-listen {
                background: hsla(0, 80%, 60%, 0.5);
                position: relative;
            }

            .status-bad-listen::before {
                content: 'Bad listen address: ' attr(data-listen);
                visibility: hidden;
                opacity: 0;
                background-color: white;
                border: 1px solid gray;
                padding: 5px;
                border-radius: 3px;

                position: absolute;
                z-index: 1;
                left: 0;
                top: 110%;
            }

            .status-bad-listen:hover::before {
                opacity: 1;
                visibility: visible;
            }

            .name-or-host {
                display: flex;
            }

            .name-or-host > :first-child {
                flex: 1;
                padding-right: 5px;
            }

            .name-or-host > a {
                text-decoration: none;
            }

            .sort-asc, .sort-desc {
                /* font-style: oblique; */
                position: relative;
                padding: 0 0.8em 0 0.2em;
            }

            .sort-asc::after, .sort-desc::after {
                position: absolute;
                right: 2px;
            }

            .sort-asc::after {
                content: '▵';
                top: -0.3em;
            }

            .sort-desc::after {
                content: '▿';
            }
        </style>
    </head>
    <body>
        <section data-bind="if: !started()">
            <ul>
                <!-- ko foreach: peers -->
                <li data-bind="css: { bad: !addressUrl() }">
                    <input type="text" data-bind="value: address, valueUpdate: 'afterkeydown'" />
                    <button data-bind="click: () => $parent.removePeer($index())">x</button>
                </li>
                <!-- /ko -->
                <li><button data-bind="click: addBlankPeer">+</button></li>
                <li><button data-bind="click: start, disable: !readyToStart()">Start</button></li>
            </ul>
        </section>

        <main data-bind="if: started">
            <input name="active" type="checkbox" data-bind="checked: filterActive" />
            <label for="active">Hide unresponsive peers</label>

            <!-- <input name="showValKey" type="checkbox" data-bind="checked: showValKey" />
            <label for="showValKey">Show full validator key</label> -->

            <table>
                <thead>
                    <tr>
                        <th rowspan="2" data-bind="sort-by: 'name'">Name / Host</th>
                        <th rowspan="2" data-bind="sort-by: 'version'">Version</th>
                        <th colspan="3">Validator</th>
                        <th colspan="4">DN</th>
                        <th colspan="4">BVN</th>
                    </tr>
                    <tr>
                        <!-- Validator -->
                        <th data-bind="sort-by: 'partition'" class="sort-asc">Partition</th>
                        <th data-bind="sort-by: 'validatorId'" class="sort-asc">ID</th>
                        <th data-bind="sort-by: 'validatorKey'">Key</th>

                        <!-- DN -->
                        <th data-bind="sort-by: 'dnId'">ID</th>
                        <th>Height</th>
                        <th>Peers</th>
                        <th data-bind="sort-by: 'dnVoting'">Voting</th>

                        <!-- BVN -->
                        <th data-bind="sort-by: 'bvnId'">ID</th>
                        <th>Height</th>
                        <th>Peers</th>
                        <th data-bind="sort-by: 'bvnVoting'">Voting</th>
                    </tr>
                </thead>
                <tbody data-bind="foreach: peers.sort((a, b) => comparePeers(a, b)).filter(x => !filterActive() || !!x.version())">
                    <tr>
                        <td class="name-or-host">
                            <!-- ko if: addressUrl --><span data-bind="text: operator() || addressUrl().hostname"></span><!-- /ko -->
                            <a data-bind="attr: { href: nodeLink }" target="_blank">🔗</button>
                        </td>
                        <td><span data-bind="text: version"></span></td>

                        <!-- Validator -->
                        <td><span data-bind="text: validator().partition"></span></td>
                        <td><span class="mono" data-bind="text: validator().id.substr(0, 8)"></span></td>
                        <td>
                            <span class="mono" data-bind="text: $parent.showValKey() ? validator().key : validator().key.substr(0, 8)"></span>
                            <!-- ko if: dnStatus--><button data-bind="click: copyValidatorKey">📋</button><!-- /ko -->
                        </td>

                        <!-- DN -->
                        <td data-bind="class: 'status-'+dn().status, attr: { 'data-listen': dn().listen_addr }"><span data-bind="text: dn().id.substr(0, 8)" class="mono"></span></td>
                        <td data-bind="class: 'status-'+dn().status, attr: { 'data-listen': dn().listen_addr }"><span data-bind="text: dn().height"></span></td>
                        <td data-bind="class: 'status-'+dn().status, attr: { 'data-listen': dn().listen_addr }"><span data-bind="text: dn().peers.length || ''"></span></td>
                        <td data-bind="class: 'status-'+dn().status, attr: { 'data-listen': dn().listen_addr }"><span data-bind="if: dn().voting_power > 0">✔</span></td>

                        <!-- BVN -->
                        <td data-bind="class: 'status-'+bvn().status, attr: { 'data-listen': bvn().listen_addr }"><span data-bind="text: bvn().id.substr(0, 8)" class="mono"></span></td>
                        <td data-bind="class: 'status-'+bvn().status, attr: { 'data-listen': bvn().listen_addr }"><span data-bind="text: bvn().height"></span></td>
                        <td data-bind="class: 'status-'+bvn().status, attr: { 'data-listen': bvn().listen_addr }"><span data-bind="text: bvn().peers.length || ''"></span></td>
                        <td data-bind="class: 'status-'+bvn().status, attr: { 'data-listen': bvn().listen_addr }"><span data-bind="if: bvn().voting_power > 0">✔</span></td>
                    </tr>
                </tbody>
                <tbody data-bind="foreach: missingValidators">
                    <tr>
                        <td colspan="2"></td>

                        <!-- Validator -->
                        <td><span data-bind="text: partitions.filter(x => x.active && x.id != 'Directory').map(x => x.id).join(', ')"></span></td>
                        <td><span class="mono" data-bind="text: publicKeyHash.substr(0, 8)"></span></td>
                        <td>
                            <span class="mono" data-bind="text: $parent.showValKey() ? publicKey : publicKey.substr(0, 8)"></span>
                            <button data-bind="click: copyValidatorKey">📋</button>
                        </td>

                        <!-- DN -->
                        <td colspan="4"></td>

                        <!-- BVN -->
                        <td colspan="4"></td>
                    </tr>
                </tbody>
            </table>
        </main>
    </body>
</html>